%             phiSSnABCproc.m
% s-stage Splitting method.
% fA, fB: flows associated to the vectorfields
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t x] = phiSSnABCproc(t0,tf,x0,N,al,s,ga,np)
% coefficients of the problem
global A B C
%A=0; B=2; C=3;
h = (tf-t0)/N;
ah=h*al;gh=h*ga;
t=t0:h:tf; x=x0';  y=x0;
%    for j=np:-1:1;
    for j=1:np;
        y = phiAh(y,gh(j)/2,A);
        y = phiBh(y,gh(j)/2,B);
        y = phiCh(y,gh(j),C);
        y = phiBh(y,gh(j)/2,B);
        y = phiAh(y,gh(j)/2,A);
    end

for i=1:N;
    for j=1:s;
        y = phiAh(y,ah(j)/2,A);
        y = phiBh(y,ah(j)/2,B);
        y = phiCh(y,ah(j),C);
        y = phiBh(y,ah(j)/2,B);
        y = phiAh(y,ah(j)/2,A);
    end
end
    for j=np:-1:1;
%    for j=1:np;
        y = phiAh(y,-gh(j)/2,A);
        y = phiBh(y,-gh(j)/2,B);
        y = phiCh(y,-gh(j),C);
        y = phiBh(y,-gh(j)/2,B);
        y = phiAh(y,-gh(j)/2,A);
    end

x = [x ; y ];
end

